# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from .. import utilities, tables

class GetLBResult(object):
    """
    A collection of values returned by getLB.
    """
    def __init__(__self__, frontend_ip_configurations=None, location=None, private_ip_address=None, private_ip_addresses=None, sku=None, tags=None, id=None):
        if frontend_ip_configurations and not isinstance(frontend_ip_configurations, list):
            raise TypeError('Expected argument frontend_ip_configurations to be a list')
        __self__.frontend_ip_configurations = frontend_ip_configurations
        """
        (Optional) A `frontend_ip_configuration` block as documented below.
        """
        if location and not isinstance(location, str):
            raise TypeError('Expected argument location to be a str')
        __self__.location = location
        """
        The Azure location where the Load Balancer exists.
        """
        if private_ip_address and not isinstance(private_ip_address, str):
            raise TypeError('Expected argument private_ip_address to be a str')
        __self__.private_ip_address = private_ip_address
        """
        Private IP Address to assign to the Load Balancer.
        """
        if private_ip_addresses and not isinstance(private_ip_addresses, list):
            raise TypeError('Expected argument private_ip_addresses to be a list')
        __self__.private_ip_addresses = private_ip_addresses
        """
        The list of private IP address assigned to the load balancer in `frontend_ip_configuration` blocks, if any.
        """
        if sku and not isinstance(sku, str):
            raise TypeError('Expected argument sku to be a str')
        __self__.sku = sku
        """
        The SKU of the Load Balancer.
        """
        if tags and not isinstance(tags, dict):
            raise TypeError('Expected argument tags to be a dict')
        __self__.tags = tags
        """
        A mapping of tags assigned to the resource.
        """
        if id and not isinstance(id, str):
            raise TypeError('Expected argument id to be a str')
        __self__.id = id
        """
        id is the provider-assigned unique ID for this managed resource.
        """

async def get_lb(name=None, resource_group_name=None):
    """
    Use this data source to access information about an existing Load Balancer
    """
    __args__ = dict()

    __args__['name'] = name
    __args__['resourceGroupName'] = resource_group_name
    __ret__ = await pulumi.runtime.invoke('azure:lb/getLB:getLB', __args__)

    return GetLBResult(
        frontend_ip_configurations=__ret__.get('frontendIpConfigurations'),
        location=__ret__.get('location'),
        private_ip_address=__ret__.get('privateIpAddress'),
        private_ip_addresses=__ret__.get('privateIpAddresses'),
        sku=__ret__.get('sku'),
        tags=__ret__.get('tags'),
        id=__ret__.get('id'))
